'****************************************************************
'*  Name    : SERVOTESTER-LCD.BAS                               *
'*  Author  : Branko Zupan                                      *
'*  Notice  : Copyright (c) 2009 Branko Zupan                   *
'*          : All Rights Reserved                               *
'*  Date    : 28.4.2009                                         *
'* B0 = Tipka - S1     (In)   A0 = LCD Enable     (Out)         *
'* B1 = Tipka + S1     (In)   A1 = LCD RS         (Out)         *
'* B2 = Tipka - S2     (In)   A2 = izhod "SERVO1" (Out)         *
'* B3 = Tipka + S2     (In)   A3 = izhod "SERVO2" (Out)         *
'* B4 = LCD Bit 4      (Out)  A4 = Tipka MODE     (In)          *
'* B5 = LCD Bit 5      (Out)                                    *
'* B6 = LCD Bit 6      (Out)                                    *
'* B7 = LCD Bit 7      (Out)  PIC16F628 Code size = 915 Words   *
'*                                                              * 
'* Oscillator XP (4 MHz.) - Power up timer enabled - MCR enable *
'****************************************************************
@ DEVICE XT_OSC,WDT_ON,PWRT_ON,PROTECT_OFF
INCLUDE "bs2defs.bas"
output PORTA.0
output PORTA.1
output PORTA.2
output PORTA.3
input PORTA.4
input PORTB.0
input PORTB.1
input PORTB.2
input PORTB.3
output PORTB.4
output PORTB.5
output PORTB.6
output PORTB.7
CMCON=7                                 ' onemogoi komparatorje

DEFINE LCD_DREG PORTB                   ' LCD on port B
DEFINE LCD_DBIT 4                       ' Data biti B4..B7
DEFINE LCD_RSREG PORTA                  ' RS na PORTA
DEFINE LCD_RSBIT 1                      ' RS na A1 
DEFINE LCD_EREG PORTA                   ' E na PORTA
DEFINE LCD_EBIT 0                       ' E na A0
DEFINE LCD_BITS 4                       ' LCD 4 bit nain
DEFINE LCD_LINES 2                      ' 2 vrstini LCD display
DEFINE BUTTON_PAUSE 50                  ' button debounce delay is 50ms

symbol minusS1 = PORTB.2     'tipka za odtevanje servo1
symbol plusS1 = PORTB.3      'tipka za pritevanje servo1
symbol SERVO1 = PORTA.2      'impulsi za servo1
symbol minusS2 = PORTB.0     'tipka za odtevanje servo2
symbol plusS2 = PORTB.1      'tipka za pritevanje servo1
symbol SERVO2 = PORTA.3      'impulsi za servo2
symbol MENU = PORTA.4        'tipka za izbiro menija

servo1_puls var word
servo2_puls var word
K1 var byte
K2 var byte

start:
read 0, servo1_puls'
read 5, servo2_puls'
read 2, k1
read 7, k2
servo1_puls = servo1_puls * 10
servo2_puls = servo2_puls * 10

pause 100                   'akanje inicijalizacije displeja 

pulsi:                      'zaetek zanke za impulse
gosub tipke                 'pogleda e je kaj pritisnjeno
high servo1                 'izhod S1 visoko
pauseus servo1_puls         'pauza v mS
low servo1                  'izhod S1 nizko
high servo2                 'izhod S2 visoko
pauseus servo2_puls         'pauza v mS
low servo2                  'izhod S2 nizko
goto pulsi                  'povratek na zaetek zanke

tipke:
if minuss1 = 0 then servo1_puls = servo1_puls - k1
if pluss1 = 0 then servo1_puls = servo1_puls + k1
if minuss2 = 0 then servo2_puls = servo2_puls - k2
if pluss2 = 0 then servo2_puls = servo2_puls + k2
pause 10
if servo1_puls < 900 then servo1_puls = 900
if servo2_puls < 900 then servo2_puls = 900
if servo1_puls > 2100 then servo1_puls = 2100
if servo2_puls > 2100 then servo2_puls = 2100
lcdout $fe,1, "S1->", dec4 servo1_puls     'izpisuje v prvo linijo
LCDOUT $FE, $C0, "S2->", dec4 servo2_puls  'izpisuje v drugo linijo
if menu = 0 then goto shrani
return

shrani:
lcdout $fe,1, "Shranim?"',   'izpisuje v prvo linijo
LCDOUT $FE, $C0, "+Da  -Ne"  'izpisuje v drugo linijo
if minuss1 = 0 then goto korak
if pluss1 = 0 then goto shrani1
if minuss2 = 0 then goto korak
if pluss2 = 0 then goto shrani1
pause 500
goto shrani

shrani1:
write 0, servo1_puls/10
write 5, servo2_puls/10
pause 100
lcdout $fe,1, "SHRANIL!"',   'izpisuje v prvo linijo
LCDOUT $FE, $C0, "S1 in S2"  'izpisuje v drugo linijo
pause 2000
lcdout $fe,1, "Ponovni"',    'izpisuje v prvo linijo
LCDOUT $FE, $C0, "zagon !"   'izpisuje v drugo linijo
pause 1000
goto start

korak:
if minuss1 = 0 then k1 = k1 - 1
if pluss1 = 0 then k1 = k1 + 1
if minuss2 = 0 then k2 = k2 - 1
if pluss2 = 0 then k2 = k2 + 1
pause 300
if k1 < 1 then k1 = 1
if k2 < 1 then k2 = 1
if k1 > 200 then k1 = 200
if k2 > 200 then k2 = 200
lcdout $fe,1, "K1->", dec3 k1    'izpisuje v prvo linijo
LCDOUT $FE, $C0, "K2->", dec3 k2 'izpisuje v drugo linijo
if menu = 0 then goto korak_shrani
goto korak

korak_shrani:
lcdout $fe,1, "Shranim?"',   'izpisuje v prvo linijo
LCDOUT $FE, $C0, "+Da  -Ne"  'izpisuje v drugo linijo
if minuss1 = 0 then goto korak
if pluss1 = 0 then goto korak_shrani1
if minuss2 = 0 then goto korak
if pluss2 = 0 then goto korak_shrani1
pause 500
goto korak_shrani

korak_shrani1:
write 2, k1
write 7, k2
pause 100
lcdout $fe,1, "SHRANIL!"',   'izpisuje v prvo linijo
LCDOUT $FE, $C0, "K1 in K2"  'izpisuje v drugo linijo
pause 2000
lcdout $fe,1, "Ponovni"',    'izpisuje v prvo linijo
LCDOUT $FE, $C0, "zagon !"   'izpisuje v drugo linijo
pause 1000
goto start
end
